Skip to content

Feedback

This tutorial shows you how to build an emoji feedback cell using Handsontableโ€™s editorFactory helper, with Handsontable CSS tokens for theme-aware styling and keyboard navigation.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
import { editorFactory } from 'handsontable/editors';
import { registerCellType } from 'handsontable/cellTypes';
// Register all Handsontable's modules.
registerAllModules();
/* start:skip-in-preview */
const data = [
{ feature: 'Dark Mode', category: 'UI', priority: 'High', feedback: '๐Ÿ‘', votes: 124, status: 'Planned' },
{ feature: 'Bulk Edit', category: 'Core', priority: 'High', feedback: '๐Ÿ‘', votes: 98, status: 'In Progress' },
{ feature: 'AI Suggestions', category: 'Beta', priority: 'Medium', feedback: '๐Ÿคท', votes: 45, status: 'Research' },
{ feature: 'Offline Mode', category: 'Infra', priority: 'Low', feedback: '๐Ÿ‘Ž', votes: 12, status: 'Backlog' },
];
/* end:skip-in-preview */
// Get the DOM element with the ID 'example1' where the Handsontable will be rendered
const container = document.querySelector('#example1');
const cellDefinition = {
editor: editorFactory({
config: ['๐Ÿ‘', '๐Ÿ‘Ž', '๐Ÿคท'],
value: '๐Ÿ‘',
shortcuts: [
{
keys: [['ArrowRight'], ['Tab']],
callback: (editor, _event) => {
let index = editor.config.indexOf(editor.value);
index = index === editor.config.length - 1 ? 0 : index + 1;
editor.setValue(editor.config[index]);
return false; // Prevent default tabbing behavior
},
},
{
keys: [['ArrowLeft']],
callback: (editor, _event) => {
let index = editor.config.indexOf(editor.value);
index = index === 0 ? editor.config.length - 1 : index - 1;
editor.setValue(editor.config[index]);
},
},
],
render: (editor) => {
editor.input.innerHTML = editor.config
.map((option) => `<button class="${editor.value === option ? 'active' : ''}">${option}</button>`)
.join('');
},
init: (editor) => {
editor.input = document.createElement('DIV');
editor.input.classList.add('feedback-editor');
editor._openedAt = 0;
editor.input.addEventListener('click', (event) => {
// Ignore synthetic click events that Android fires right after the editor
// opens โ€” they land on the button that just appeared at the touch position.
if (Date.now() - editor._openedAt < 300) {
return;
}
if (event.target instanceof HTMLButtonElement) {
editor.setValue(event.target.innerText);
editor.finishEditing();
}
});
editor.render(editor);
},
afterOpen: (editor) => {
editor._openedAt = Date.now();
},
beforeOpen: (editor, { originalValue, cellProperties }) => {
editor.setValue(originalValue);
},
}),
};
registerCellType('feedback', cellDefinition);
// Define configuration options for the Handsontable
const hotOptions = {
data,
colHeaders: ['Feature', 'Category', 'Priority', 'Feedback', 'Votes', 'Status'],
autoRowSize: true,
rowHeaders: true,
autoWrapRow: true,
height: 'auto',
width: '100%',
headerClassName: 'htLeft',
columns: [
{ data: 'feature', type: 'text', width: 200 },
{ data: 'category', type: 'text', width: 90 },
{ data: 'priority', type: 'text', width: 100 },
{ data: 'feedback', width: 100, type: 'feedback' },
{ data: 'votes', type: 'numeric', width: 60 },
{ data: 'status', type: 'text', width: 120 },
],
licenseKey: 'non-commercial-and-evaluation',
};
// Initialize the Handsontable instance with the specified configuration options
// eslint-disable-next-line no-unused-vars
const hot = new Handsontable(container, hotOptions);
TypeScript
import Handsontable from "handsontable/base";
import { registerAllModules } from "handsontable/registry";
import { CellProperties } from "handsontable/settings";
import { BaseEditor } from "handsontable/editors/baseEditor";
import { editorFactory } from "handsontable/editors";
import { registerCellType } from 'handsontable/cellTypes';
// Register all Handsontable's modules.
registerAllModules();
/* start:skip-in-preview */
const data = [
{ feature: "Dark Mode", category: "UI", priority: "High", feedback: "๐Ÿ‘", votes: 124, status: "Planned" },
{ feature: "Bulk Edit", category: "Core", priority: "High", feedback: "๐Ÿ‘", votes: 98, status: "In Progress" },
{ feature: "AI Suggestions", category: "Beta", priority: "Medium", feedback: "๐Ÿคท", votes: 45, status: "Research" },
{ feature: "Offline Mode", category: "Infra", priority: "Low", feedback: "๐Ÿ‘Ž", votes: 12, status: "Backlog" },
];
/* end:skip-in-preview */
// Get the DOM element with the ID 'example1' where the Handsontable will be rendered
const container = document.querySelector("#example1")!;
const cellDefinition: Pick<
CellProperties,
"renderer" | "validator" | "editor"
> = {
editor: editorFactory<
{ input: HTMLDivElement; value: string; config: string[] }
>({
config: ["๐Ÿ‘", "๐Ÿ‘Ž", "๐Ÿคท"],
value: "๐Ÿ‘",
shortcuts: [
{
keys: [["ArrowRight"], ["Tab"]],
callback: (editor, _event) => {
let index = editor.config.indexOf(editor.value);
index = index === editor.config.length - 1 ? 0 : index + 1;
editor.setValue(editor.config[index]);
return false; // Prevent default tabbing behavior
},
},
{
keys: [["ArrowLeft"]],
callback: (editor, _event) => {
let index = editor.config.indexOf(editor.value);
index = index === 0 ? editor.config.length - 1 : index - 1;
editor.setValue(editor.config[index]);
},
},
],
render: (editor) => {
editor.input.innerHTML = editor.config
.map(
(option) =>
`<button class="${editor.value === option ? "active" : ""}">${option}</button>`,
)
.join("");
},
init: (editor) => {
editor.input = document.createElement("DIV") as HTMLDivElement;
editor.input.classList.add("feedback-editor");
editor._openedAt = 0;
editor.input.addEventListener("click", (event) => {
// Ignore synthetic click events that Android fires right after the editor
// opens โ€” they land on the button that just appeared at the touch position.
if (Date.now() - editor._openedAt < 300) {
return;
}
if (event.target instanceof HTMLButtonElement) {
editor.setValue(event.target.innerText);
editor.finishEditing();
}
});
editor.render(editor);
},
afterOpen: (editor) => {
editor._openedAt = Date.now();
},
beforeOpen: (editor, { originalValue, cellProperties }) => {
editor.setValue(originalValue);
},
}),
};
registerCellType('feedback', cellDefinition as BaseEditor);
// Define configuration options for the Handsontable
const hotOptions: Handsontable.GridSettings = {
data,
colHeaders: ["Feature", "Category", "Priority", "Feedback", "Votes", "Status"],
autoRowSize: true,
rowHeaders: true,
autoWrapRow: true,
height: "auto",
width: "100%",
headerClassName: "htLeft",
columns: [
{ data: "feature", type: "text", width: 200 },
{ data: "category", type: "text", width: 90 },
{ data: "priority", type: "text", width: 100 },
{ data: "feedback", width: 100, type: "feedback" },
{ data: "votes", type: "numeric", width: 60 },
{ data: "status", type: "text", width: 120 },
],
licenseKey: "non-commercial-and-evaluation",
};
// Initialize the Handsontable instance with the specified configuration options
// eslint-disable-next-line no-unused-vars
const hot = new Handsontable(container, hotOptions);
CSS
.feedback-editor {
display: flex;
gap: var(--ht-gap, 4px);
width: 100%;
height: 100%;
box-sizing: border-box !important;
padding: var(--ht-cell-vertical-padding, 4px) var(--ht-cell-horizontal-padding, 8px);
background-color: var(--ht-cell-editor-background-color, #ffffff);
box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
var(--ht-cell-editor-border-color, #1a42e8),
0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
var(--ht-cell-editor-shadow-color, transparent);
border: none;
border-radius: 0;
}
.feedback-editor button {
display: block;
background: var(--ht-background-color, #ffffff);
color: var(--ht-foreground-color, #000000);
border: 1px solid var(--ht-border-color, #e0e0e0);
border-radius: var(--ht-border-radius, 4px);
padding: 0;
margin: 0;
height: 100%;
width: 33%;
font-size: var(--ht-font-size, 14px);
text-align: center;
cursor: pointer;
}
.feedback-editor button:hover {
background: var(--ht-border-color, #e0e0e0);
}
.feedback-editor button.active,
.feedback-editor button.active:hover {
background: var(--ht-accent-color, #1a42e8);
color: #ffffff;
border-color: var(--ht-accent-color, #1a42e8);
}

Overview

This guide shows how to create a feedback editor cell using emoji buttons. Use it for status indicators or any scenario where users choose from a small set of visual options.

Difficulty: Beginner Time: ~15 minutes Libraries: None (pure HTML)

What Youโ€™ll Build

A cell that:

  • Displays emoji feedback buttons (rounded) when editing
  • Shows the selected emoji when viewing
  • Uses Handsontable CSS tokens for theme-aware styling
  • Supports keyboard navigation (arrow keys, Tab)
  • Provides click-to-select functionality
  • Works without any external libraries

Prerequisites

None! This uses only native HTML and JavaScript features.

  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { editorFactory } from 'handsontable/editors';
    import { registerCellType } from 'handsontable/cellTypes';
    registerAllModules();

    What weโ€™re NOT importing:

    • No date libraries
    • No UI component libraries
    • No external emoji libraries
    • Handsontable only.
  2. Add CSS Styling

    Create a separate CSS file for the editor styles. This uses Handsontable CSS custom properties (tokens) so the editor automatically adapts to custom themes and dark mode.

    .feedback-editor {
    display: flex;
    gap: var(--ht-gap, 4px);
    width: 100%;
    height: 100%;
    box-sizing: border-box !important;
    padding: var(--ht-cell-vertical-padding, 4px) var(--ht-cell-horizontal-padding, 8px);
    background-color: var(--ht-cell-editor-background-color, #ffffff);
    box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
    var(--ht-cell-editor-border-color, #1a42e8),
    0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
    var(--ht-cell-editor-shadow-color, transparent);
    border: none;
    border-radius: 0;
    }
    .feedback-editor button {
    background: var(--ht-background-color, #ffffff);
    color: var(--ht-foreground-color, #000000);
    border: 1px solid var(--ht-border-color, #e0e0e0);
    border-radius: var(--ht-border-radius, 4px);
    padding: 0;
    margin: 0;
    height: 100%;
    width: 33%;
    font-size: var(--ht-font-size, 14px);
    text-align: center;
    cursor: pointer;
    }
    .feedback-editor button:hover {
    background: var(--ht-border-color, #e0e0e0);
    }
    .feedback-editor button.active,
    .feedback-editor button.active:hover {
    background: var(--ht-accent-color, #1a42e8);
    color: #ffffff;
    border-color: var(--ht-accent-color, #1a42e8);
    }

    Handsontable tokens used:

    • --ht-cell-editor-border-color / --ht-cell-editor-border-width - blue border matching native editors
    • --ht-cell-editor-background-color - editor background
    • --ht-cell-vertical-padding / --ht-cell-horizontal-padding - consistent cell padding
    • --ht-background-color / --ht-foreground-color - base button colors
    • --ht-border-color - button borders and hover state
    • --ht-accent-color - active/selected button highlight
    • --ht-border-radius - button corner rounding
    • --ht-font-size / --ht-gap - consistent sizing
  3. Editor - Initialize (init)

    Create the DOM structure with emoji buttons, this function will be called only once.

    init(editor) {
    editor.input = document.createElement('DIV') as HTMLDivElement;
    editor.input.classList.add('feedback-editor');
    editor._openedAt = 0;
    editor.input.addEventListener('click', (event) => {
    // Ignore synthetic click events that Android fires right after the editor
    // opens โ€” they land on the button that just appeared at the touch position.
    if (Date.now() - editor._openedAt < 300) {
    return;
    }
    if (event.target instanceof HTMLButtonElement) {
    editor.setValue(event.target.innerText);
    editor.finishEditing();
    }
    });
    editor.render(editor);
    }

    Whatโ€™s happening:

    1. Create a div container for the buttons
    2. Add the feedback-editor CSS class (all styling is in the CSS file)
    3. Add click handler to detect button clicks
    4. When a button is clicked, set the value and finish editing
    5. Call render to create the initial button layout
  4. Editor - Render Function

    Create buttons dynamically based on the config, using CSS classes instead of inline styles.

    render(editor) {
    editor.input.innerHTML = editor.config
    .map((option) =>
    `<button class="${editor.value === option ? 'active' : ''}">${option}</button>`
    )
    .join('');
    }

    Whatโ€™s happening:

    • Generate HTML for each button from config array
    • Add active class to the currently selected button
    • The .active CSS class applies --ht-accent-color as background
    • Each button takes 33% width with rounded corners (--ht-border-radius)
  5. Editor - Keyboard Shortcuts

    Add arrow key navigation to cycle through options.

    shortcuts: [
    {
    keys: [['ArrowRight']],
    callback: (editor, _event) => {
    let index = editor.config.indexOf(editor.value);
    index = index === editor.config.length - 1 ? 0 : index + 1;
    editor.setValue(editor.config[index]);
    }
    },
    {
    keys: [['ArrowLeft']],
    callback: (editor, _event) => {
    let index = editor.config.indexOf(editor.value);
    index = index === 0 ? editor.config.length - 1 : index - 1;
    editor.setValue(editor.config[index]);
    }
    }
    ]

    Whatโ€™s happening:

    • ArrowRight: Move to next option (wraps to first if at end)
    • ArrowLeft: Move to previous option (wraps to last if at start)
    • Finds current index in config array
    • Updates value and triggers render automatically

    Keyboard navigation benefits:

    • Fast selection without mouse
    • Accessible for keyboard-only users
    • Intuitive left/right navigation
  6. Editor โ€“ Custom Tab Key Behavior

    By default, pressing Tab in Handsontable saves the cell and moves the selection horizontally, following your layout direction. In this example, Tab cycles through feedback options โ€” the same as the arrow keys โ€” without moving to another cell. The editorโ€™s shortcuts option handles this by returning false in the callback to prevent the default action (saving and moving to the next cell).

    shortcuts: [
    {
    keys: [['ArrowRight'], ['Tab']],
    callback: (editor, _event) => {
    let index = editor.config.indexOf(editor.value);
    index = index === editor.config.length - 1 ? 0 : index + 1;
    editor.setValue(editor.config[index]);
    return false; // Prevent default tabbing behavior
    },
    },
    ]

    How it works:

    • Listens for Tab when the editor is active
    • Moves to the next option in config (wraps around at the end)
    • Updates the editorโ€™s value and button highlight
    • Returning false blocks Handsontableโ€™s built-in tab handler, so editing stays in place
  7. Editor - Before Open Hook

    Initialize the editor with the current cell value when editing starts.

    beforeOpen(editor, { originalValue, cellProperties }) {
    editor.setValue(originalValue);
    }

    Whatโ€™s happening:

    • Called when editor is about to open
    • Receives the current cell value as originalValue
    • Sets the editorโ€™s value to match the cell
    • This ensures the correct button is highlighted when editing starts
  8. Complete Cell Definition

    const cellDefinition = {
    editor: editorFactory<{ input: HTMLDivElement; value: string; config: string[] }>({
    config: ['๐Ÿ‘', '๐Ÿ‘Ž', '๐Ÿคท'],
    value: '๐Ÿ‘',
    shortcuts: [
    {
    keys: [['ArrowRight'], ['Tab']],
    callback: (editor, _event) => {
    let index = editor.config.indexOf(editor.value);
    index = index === editor.config.length - 1 ? 0 : index + 1;
    editor.setValue(editor.config[index]);
    return false;
    },
    },
    {
    keys: [['ArrowLeft']],
    callback: (editor, _event) => {
    let index = editor.config.indexOf(editor.value);
    index = index === 0 ? editor.config.length - 1 : index - 1;
    editor.setValue(editor.config[index]);
    },
    },
    ],
    render: (editor) => {
    editor.input.innerHTML = editor.config
    .map(
    (option) =>
    `<button class="${editor.value === option ? 'active' : ''}">${option}</button>`,
    )
    .join('');
    },
    init: (editor) => {
    editor.input = document.createElement('DIV') as HTMLDivElement;
    editor.input.classList.add('feedback-editor');
    editor._openedAt = 0;
    editor.input.addEventListener('click', (event) => {
    if (Date.now() - editor._openedAt < 300) {
    return;
    }
    if (event.target instanceof HTMLButtonElement) {
    editor.setValue(event.target.innerText);
    editor.finishEditing();
    }
    });
    editor.render(editor);
    },
    afterOpen: (editor) => {
    editor._openedAt = Date.now();
    },
    beforeOpen: (editor, { originalValue, cellProperties }) => {
    editor.setValue(originalValue);
    },
    }),
    };

    Whatโ€™s happening:

    • config: Array of emoji options (๐Ÿ‘, ๐Ÿ‘Ž, ๐Ÿคท)
    • value: Default/initial value
    • shortcuts: Keyboard navigation (ArrowLeft/ArrowRight cycle options, Tab cycles and prevents default)
    • render: Creates button HTML with active CSS class for the selected option
    • init: Sets up the container with feedback-editor class and click handler
    • beforeOpen: Initializes editor with the current cell value

    Note: No custom renderer needed! Handsontableโ€™s default renderer will display the emoji value in the cell. All visual styling is handled by the CSS file using Handsontable tokens.

  9. Register and Use in Handsontable

    Register the cell definition as a reusable cell type, then use it in the column configuration.

    registerCellType('feedback', cellDefinition);
    const container = document.querySelector('#example1')!;
    const hotOptions: Handsontable.GridSettings = {
    data: [
    { feature: 'Dark Mode', category: 'UI', priority: 'High', feedback: '๐Ÿ‘', votes: 124, status: 'Planned' },
    { feature: 'Bulk Edit', category: 'Core', priority: 'High', feedback: '๐Ÿ‘', votes: 98, status: 'In Progress' },
    { feature: 'AI Suggestions', category: 'Beta', priority: 'Medium', feedback: '๐Ÿคท', votes: 45, status: 'Research' },
    { feature: 'Offline Mode', category: 'Infra', priority: 'Low', feedback: '๐Ÿ‘Ž', votes: 12, status: 'Backlog' },
    ],
    colHeaders: ['Feature', 'Category', 'Priority', 'Feedback', 'Votes', 'Status'],
    autoRowSize: true,
    rowHeaders: true,
    autoWrapRow: true,
    height: 'auto',
    width: '100%',
    headerClassName: 'htLeft',
    columns: [
    { data: 'feature', type: 'text', width: 200 },
    { data: 'category', type: 'text', width: 90 },
    { data: 'priority', type: 'text', width: 100 },
    { data: 'feedback', width: 100, type: 'feedback' },
    { data: 'votes', type: 'numeric', width: 60 },
    { data: 'status', type: 'text', width: 120 },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    };
    const hot = new Handsontable(container, hotOptions);

    Key configuration:

    • registerCellType('feedback', cellDefinition) - Registers the editor as a reusable cell type
    • type: 'feedback' - Applies the cell type to the Feedback column
    • headerClassName: 'htLeft' - Left-aligns all column headers

How It Works - Complete Flow

  1. Initial Render: Cell displays the emoji value (๐Ÿ‘, ๐Ÿ‘Ž, or ๐Ÿคท)
  2. User Double-Clicks or Enter: Editor opens over cell showing three rounded buttons with the Handsontable blue border
  3. Button Display: All options visible, current value highlighted using --ht-accent-color
  4. User Interaction:
    • Click a button: Selects value and closes editor
    • Press ArrowLeft/ArrowRight: Cycles through options
    • Press Tab: Cycles through options (stays in editor)
    • Enter key saves value and closes editor
  5. Visual Feedback: Selected button highlighted with accent color
  6. Save: Value saved to cell
  7. Editor Closes: Cell shows selected emoji

Enhancements

  1. More Feedback Options

    Add more emoji options by extending the config array and adjusting the button width in CSS:

    config: ['๐Ÿ‘', '๐Ÿ‘Ž', '๐Ÿคท', 'โค๏ธ', '๐Ÿ”ฅ', 'โญ'],
  2. Dynamic Config from Cell Properties

    Make options configurable per column:

    beforeOpen: (editor, { cellProperties }) => {
    if (cellProperties.feedbackOptions) {
    editor.config = cellProperties.feedbackOptions;
    }
    editor.setValue(editor.originalValue || editor.value);
    },
    // Usage
    columns: [{
    data: 'feedback',
    type: 'feedback',
    feedbackOptions: ['๐Ÿ‘', '๐Ÿ‘Ž', 'โค๏ธ', '๐Ÿ”ฅ']
    }]
  3. Tooltip on Hover

    Add tooltips to buttons:

    render: (editor) => {
    const tooltips = { '๐Ÿ‘': 'Positive', '๐Ÿ‘Ž': 'Negative', '๐Ÿคท': 'Neutral' };
    editor.input.innerHTML = editor.config
    .map((option) =>
    `<button class="${editor.value === option ? 'active' : ''}" title="${tooltips[option] || ''}">${option}</button>`
    )
    .join('');
    }
  4. Text Labels Instead of Emojis

    Use text buttons for clarity:

    config: ['Positive', 'Negative', 'Neutral'],

Accessibility

Keyboard navigation:

  • Tab: Cycles through feedback options (stays in editor)
  • ArrowLeft / ArrowRight: Cycles through options
  • Enter: Saves value and closes editor
  • Escape: Cancels editing
  • Click: Direct selection

What you learned

You built an emoji feedback cell editor using Handsontableโ€™s editorFactory helper. You used Handsontable CSS custom properties to style the editor in a theme-aware way, and registered the result as a reusable cell type with registerCellType.

Next steps

Skip to content

Feedback

This tutorial shows you how to build an emoji feedback cell using Handsontable’s editorFactory helper, with Handsontable CSS tokens for theme-aware styling and keyboard navigation.

TypeScript
/* file: app.component.ts */
import { Component, ChangeDetectorRef, inject } from '@angular/core';
import { GridSettings, HotCellEditorAdvancedComponent, KeyboardShortcutConfig, HotTableModule } from '@handsontable/angular-wrapper';
/* start:skip-in-preview */
const inputData = [
{ feature: 'Dark Mode', category: 'UI', priority: 'High', feedback: 'πŸ‘', votes: 124, status: 'Planned' },
{ feature: 'Bulk Edit', category: 'Core', priority: 'High', feedback: 'πŸ‘', votes: 98, status: 'In Progress' },
{ feature: 'AI Suggestions', category: 'Beta', priority: 'Medium', feedback: '🀷', votes: 45, status: 'Research' },
{ feature: 'Offline Mode', category: 'Infra', priority: 'Low', feedback: 'πŸ‘Ž', votes: 12, status: 'Backlog' },
];
/* end:skip-in-preview */
@Component({
standalone: true,
selector: 'example1-feedback-editor',
template: `
<div class="feedback-editor">
@for (option of config; track option) {
<button [class.active]="option === getValue()" (click)="onClick(option)">{{ option }}</button>
}
</div>
`,
})
export class FeedbackEditorComponent extends HotCellEditorAdvancedComponent<string> {
override config = ['πŸ‘', 'πŸ‘Ž', '🀷'];
override value = 'πŸ‘';
override shortcuts?: KeyboardShortcutConfig[] = [
{
keys: [['ArrowRight'], ['Tab']],
callback: (_editor, _event) => {
let index = this.config.indexOf(this.getValue());
index = index === this.config.length - 1 ? 0 : index + 1;
this.setValue(this.config[index]);
this.cdr.detectChanges();
return false;
},
},
{
keys: [['ArrowLeft']],
callback: (_editor, _event) => {
let index = this.config.indexOf(this.getValue());
index = index === 0 ? this.config.length - 1 : index - 1;
this.setValue(this.config[index]);
this.cdr.detectChanges();
},
},
];
private readonly cdr = inject(ChangeDetectorRef);
onClick(option: string): void {
this.setValue(option);
this.finishEdit.emit();
}
}
@Component({
standalone: true,
imports: [HotTableModule],
selector: 'example1-feedback',
template: `<div><hot-table [data]="data" [settings]="gridSettings"></hot-table></div>`,
})
export class AppComponent {
readonly data = inputData;
readonly gridSettings: GridSettings = {
autoRowSize: true,
rowHeaders: true,
autoWrapRow: true,
height: 'auto',
width: '100%',
headerClassName: 'htLeft',
colHeaders: ['Feature', 'Category', 'Priority', 'Feedback', 'Votes', 'Status'],
columns: [
{ data: 'feature', type: 'text', width: 200 },
{ data: 'category', type: 'text', width: 90 },
{ data: 'priority', type: 'text', width: 100 },
{ data: 'feedback', width: 100, editor: FeedbackEditorComponent },
{ data: 'votes', type: 'numeric', width: 60 },
{ data: 'status', type: 'text', width: 120 },
],
};
}
/* end-file */
/* file: app.config.ts */
import { ApplicationConfig, provideZoneChangeDetection } from '@angular/core';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
registerAllModules();
export const appConfig: ApplicationConfig = {
providers: [
provideZoneChangeDetection({ eventCoalescing: true }),
{
provide: HOT_GLOBAL_CONFIG,
useValue: { license: NON_COMMERCIAL_LICENSE } as HotGlobalConfig,
},
],
};
/* end-file */
HTML
<div>
<example1-feedback></example1-feedback>
</div>
CSS
.feedback-editor {
display: flex;
gap: var(--ht-gap, 4px);
width: 100%;
height: 100%;
box-sizing: border-box !important;
padding: var(--ht-cell-vertical-padding, 4px) var(--ht-cell-horizontal-padding, 8px);
background-color: var(--ht-cell-editor-background-color, #ffffff);
box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
var(--ht-cell-editor-border-color, #1a42e8),
0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
var(--ht-cell-editor-shadow-color, transparent);
border: none;
border-radius: 0;
}
.feedback-editor button {
display: block;
background: var(--ht-background-color, #ffffff);
color: var(--ht-foreground-color, #000000);
border: 1px solid var(--ht-border-color, #e0e0e0);
border-radius: var(--ht-border-radius, 4px);
padding: 0;
margin: 0;
height: 100%;
width: 33%;
font-size: var(--ht-font-size, 14px);
text-align: center;
cursor: pointer;
}
.feedback-editor button:hover {
background: var(--ht-border-color, #e0e0e0);
}
.feedback-editor button.active,
.feedback-editor button.active:hover {
background: var(--ht-accent-color, #1a42e8);
color: #ffffff;
border-color: var(--ht-accent-color, #1a42e8);
}

Overview

This guide shows how to create a feedback editor cell using emoji buttons. Use it for status indicators or any scenario where users choose from a small set of visual options.

Difficulty: Beginner Time: ~15 minutes Libraries: None (pure HTML)

What You’ll Build

A cell that:

  • Displays emoji feedback buttons (rounded) when editing
  • Shows the selected emoji when viewing
  • Uses Handsontable CSS tokens for theme-aware styling
  • Supports keyboard navigation (arrow keys, Tab)
  • Provides click-to-select functionality
  • Works without any external libraries

Prerequisites

None! This uses only native HTML and JavaScript features.

  1. Import Dependencies

    import Handsontable from 'handsontable/base';
    import { registerAllModules } from 'handsontable/registry';
    import { editorFactory } from 'handsontable/editors';
    import { registerCellType } from 'handsontable/cellTypes';
    registerAllModules();

    What we’re NOT importing:

    • No date libraries
    • No UI component libraries
    • No external emoji libraries
    • Handsontable only.
  2. Add CSS Styling

    Create a separate CSS file for the editor styles. This uses Handsontable CSS custom properties (tokens) so the editor automatically adapts to custom themes and dark mode.

    .feedback-editor {
    display: flex;
    gap: var(--ht-gap, 4px);
    width: 100%;
    height: 100%;
    box-sizing: border-box !important;
    padding: var(--ht-cell-vertical-padding, 4px) var(--ht-cell-horizontal-padding, 8px);
    background-color: var(--ht-cell-editor-background-color, #ffffff);
    box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
    var(--ht-cell-editor-border-color, #1a42e8),
    0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
    var(--ht-cell-editor-shadow-color, transparent);
    border: none;
    border-radius: 0;
    }
    .feedback-editor button {
    background: var(--ht-background-color, #ffffff);
    color: var(--ht-foreground-color, #000000);
    border: 1px solid var(--ht-border-color, #e0e0e0);
    border-radius: var(--ht-border-radius, 4px);
    padding: 0;
    margin: 0;
    height: 100%;
    width: 33%;
    font-size: var(--ht-font-size, 14px);
    text-align: center;
    cursor: pointer;
    }
    .feedback-editor button:hover {
    background: var(--ht-border-color, #e0e0e0);
    }
    .feedback-editor button.active,
    .feedback-editor button.active:hover {
    background: var(--ht-accent-color, #1a42e8);
    color: #ffffff;
    border-color: var(--ht-accent-color, #1a42e8);
    }

    Handsontable tokens used:

    • --ht-cell-editor-border-color / --ht-cell-editor-border-width - blue border matching native editors
    • --ht-cell-editor-background-color - editor background
    • --ht-cell-vertical-padding / --ht-cell-horizontal-padding - consistent cell padding
    • --ht-background-color / --ht-foreground-color - base button colors
    • --ht-border-color - button borders and hover state
    • --ht-accent-color - active/selected button highlight
    • --ht-border-radius - button corner rounding
    • --ht-font-size / --ht-gap - consistent sizing
  3. Editor - Initialize (init)

    Create the DOM structure with emoji buttons, this function will be called only once.

    init(editor) {
    editor.input = document.createElement('DIV') as HTMLDivElement;
    editor.input.classList.add('feedback-editor');
    editor._openedAt = 0;
    editor.input.addEventListener('click', (event) => {
    // Ignore synthetic click events that Android fires right after the editor
    // opens β€” they land on the button that just appeared at the touch position.
    if (Date.now() - editor._openedAt < 300) {
    return;
    }
    if (event.target instanceof HTMLButtonElement) {
    editor.setValue(event.target.innerText);
    editor.finishEditing();
    }
    });
    editor.render(editor);
    }

    What’s happening:

    1. Create a div container for the buttons
    2. Add the feedback-editor CSS class (all styling is in the CSS file)
    3. Add click handler to detect button clicks
    4. When a button is clicked, set the value and finish editing
    5. Call render to create the initial button layout
  4. Editor - Render Function

    Create buttons dynamically based on the config, using CSS classes instead of inline styles.

    render(editor) {
    editor.input.innerHTML = editor.config
    .map((option) =>
    `<button class="${editor.value === option ? 'active' : ''}">${option}</button>`
    )
    .join('');
    }

    What’s happening:

    • Generate HTML for each button from config array
    • Add active class to the currently selected button
    • The .active CSS class applies --ht-accent-color as background
    • Each button takes 33% width with rounded corners (--ht-border-radius)
  5. Editor - Keyboard Shortcuts

    Add arrow key navigation to cycle through options.

    shortcuts: [
    {
    keys: [['ArrowRight']],
    callback: (editor, _event) => {
    let index = editor.config.indexOf(editor.value);
    index = index === editor.config.length - 1 ? 0 : index + 1;
    editor.setValue(editor.config[index]);
    }
    },
    {
    keys: [['ArrowLeft']],
    callback: (editor, _event) => {
    let index = editor.config.indexOf(editor.value);
    index = index === 0 ? editor.config.length - 1 : index - 1;
    editor.setValue(editor.config[index]);
    }
    }
    ]

    What’s happening:

    • ArrowRight: Move to next option (wraps to first if at end)
    • ArrowLeft: Move to previous option (wraps to last if at start)
    • Finds current index in config array
    • Updates value and triggers render automatically

    Keyboard navigation benefits:

    • Fast selection without mouse
    • Accessible for keyboard-only users
    • Intuitive left/right navigation
  6. Editor – Custom Tab Key Behavior

    By default, pressing Tab in Handsontable saves the cell and moves the selection horizontally, following your layout direction. In this example, Tab cycles through feedback options β€” the same as the arrow keys β€” without moving to another cell. The editor’s shortcuts option handles this by returning false in the callback to prevent the default action (saving and moving to the next cell).

    shortcuts: [
    {
    keys: [['ArrowRight'], ['Tab']],
    callback: (editor, _event) => {
    let index = editor.config.indexOf(editor.value);
    index = index === editor.config.length - 1 ? 0 : index + 1;
    editor.setValue(editor.config[index]);
    return false; // Prevent default tabbing behavior
    },
    },
    ]

    How it works:

    • Listens for Tab when the editor is active
    • Moves to the next option in config (wraps around at the end)
    • Updates the editor’s value and button highlight
    • Returning false blocks Handsontable’s built-in tab handler, so editing stays in place
  7. Editor - Before Open Hook

    Initialize the editor with the current cell value when editing starts.

    beforeOpen(editor, { originalValue, cellProperties }) {
    editor.setValue(originalValue);
    }

    What’s happening:

    • Called when editor is about to open
    • Receives the current cell value as originalValue
    • Sets the editor’s value to match the cell
    • This ensures the correct button is highlighted when editing starts
  8. Complete Cell Definition

    const cellDefinition = {
    editor: editorFactory<{ input: HTMLDivElement; value: string; config: string[] }>({
    config: ['πŸ‘', 'πŸ‘Ž', '🀷'],
    value: 'πŸ‘',
    shortcuts: [
    {
    keys: [['ArrowRight'], ['Tab']],
    callback: (editor, _event) => {
    let index = editor.config.indexOf(editor.value);
    index = index === editor.config.length - 1 ? 0 : index + 1;
    editor.setValue(editor.config[index]);
    return false;
    },
    },
    {
    keys: [['ArrowLeft']],
    callback: (editor, _event) => {
    let index = editor.config.indexOf(editor.value);
    index = index === 0 ? editor.config.length - 1 : index - 1;
    editor.setValue(editor.config[index]);
    },
    },
    ],
    render: (editor) => {
    editor.input.innerHTML = editor.config
    .map(
    (option) =>
    `<button class="${editor.value === option ? 'active' : ''}">${option}</button>`,
    )
    .join('');
    },
    init: (editor) => {
    editor.input = document.createElement('DIV') as HTMLDivElement;
    editor.input.classList.add('feedback-editor');
    editor._openedAt = 0;
    editor.input.addEventListener('click', (event) => {
    if (Date.now() - editor._openedAt < 300) {
    return;
    }
    if (event.target instanceof HTMLButtonElement) {
    editor.setValue(event.target.innerText);
    editor.finishEditing();
    }
    });
    editor.render(editor);
    },
    afterOpen: (editor) => {
    editor._openedAt = Date.now();
    },
    beforeOpen: (editor, { originalValue, cellProperties }) => {
    editor.setValue(originalValue);
    },
    }),
    };

    What’s happening:

    • config: Array of emoji options (πŸ‘, πŸ‘Ž, 🀷)
    • value: Default/initial value
    • shortcuts: Keyboard navigation (ArrowLeft/ArrowRight cycle options, Tab cycles and prevents default)
    • render: Creates button HTML with active CSS class for the selected option
    • init: Sets up the container with feedback-editor class and click handler
    • beforeOpen: Initializes editor with the current cell value

    Note: No custom renderer needed! Handsontable’s default renderer will display the emoji value in the cell. All visual styling is handled by the CSS file using Handsontable tokens.

  9. Register and Use in Handsontable

    Register the cell definition as a reusable cell type, then use it in the column configuration.

    registerCellType('feedback', cellDefinition);
    const container = document.querySelector('#example1')!;
    const hotOptions: Handsontable.GridSettings = {
    data: [
    { feature: 'Dark Mode', category: 'UI', priority: 'High', feedback: 'πŸ‘', votes: 124, status: 'Planned' },
    { feature: 'Bulk Edit', category: 'Core', priority: 'High', feedback: 'πŸ‘', votes: 98, status: 'In Progress' },
    { feature: 'AI Suggestions', category: 'Beta', priority: 'Medium', feedback: '🀷', votes: 45, status: 'Research' },
    { feature: 'Offline Mode', category: 'Infra', priority: 'Low', feedback: 'πŸ‘Ž', votes: 12, status: 'Backlog' },
    ],
    colHeaders: ['Feature', 'Category', 'Priority', 'Feedback', 'Votes', 'Status'],
    autoRowSize: true,
    rowHeaders: true,
    autoWrapRow: true,
    height: 'auto',
    width: '100%',
    headerClassName: 'htLeft',
    columns: [
    { data: 'feature', type: 'text', width: 200 },
    { data: 'category', type: 'text', width: 90 },
    { data: 'priority', type: 'text', width: 100 },
    { data: 'feedback', width: 100, type: 'feedback' },
    { data: 'votes', type: 'numeric', width: 60 },
    { data: 'status', type: 'text', width: 120 },
    ],
    licenseKey: 'non-commercial-and-evaluation',
    };
    const hot = new Handsontable(container, hotOptions);

    Key configuration:

    • registerCellType('feedback', cellDefinition) - Registers the editor as a reusable cell type
    • type: 'feedback' - Applies the cell type to the Feedback column
    • headerClassName: 'htLeft' - Left-aligns all column headers

How It Works - Complete Flow

  1. Initial Render: Cell displays the emoji value (πŸ‘, πŸ‘Ž, or 🀷)
  2. User Double-Clicks or Enter: Editor opens over cell showing three rounded buttons with the Handsontable blue border
  3. Button Display: All options visible, current value highlighted using --ht-accent-color
  4. User Interaction:
    • Click a button: Selects value and closes editor
    • Press ArrowLeft/ArrowRight: Cycles through options
    • Press Tab: Cycles through options (stays in editor)
    • Enter key saves value and closes editor
  5. Visual Feedback: Selected button highlighted with accent color
  6. Save: Value saved to cell
  7. Editor Closes: Cell shows selected emoji

Enhancements

  1. More Feedback Options

    Add more emoji options by extending the config array and adjusting the button width in CSS:

    config: ['πŸ‘', 'πŸ‘Ž', '🀷', '❀️', 'πŸ”₯', '⭐'],
  2. Dynamic Config from Cell Properties

    Make options configurable per column:

    beforeOpen: (editor, { cellProperties }) => {
    if (cellProperties.feedbackOptions) {
    editor.config = cellProperties.feedbackOptions;
    }
    editor.setValue(editor.originalValue || editor.value);
    },
    // Usage
    columns: [{
    data: 'feedback',
    type: 'feedback',
    feedbackOptions: ['πŸ‘', 'πŸ‘Ž', '❀️', 'πŸ”₯']
    }]
  3. Tooltip on Hover

    Add tooltips to buttons:

    render: (editor) => {
    const tooltips = { 'πŸ‘': 'Positive', 'πŸ‘Ž': 'Negative', '🀷': 'Neutral' };
    editor.input.innerHTML = editor.config
    .map((option) =>
    `<button class="${editor.value === option ? 'active' : ''}" title="${tooltips[option] || ''}">${option}</button>`
    )
    .join('');
    }
  4. Text Labels Instead of Emojis

    Use text buttons for clarity:

    config: ['Positive', 'Negative', 'Neutral'],

Accessibility

Keyboard navigation:

  • Tab: Cycles through feedback options (stays in editor)
  • ArrowLeft / ArrowRight: Cycles through options
  • Enter: Saves value and closes editor
  • Escape: Cancels editing
  • Click: Direct selection

What you learned

You built an emoji feedback cell editor using Handsontable’s editorFactory helper. You used Handsontable CSS custom properties to style the editor in a theme-aware way, and registered the result as a reusable cell type with registerCellType.

Next steps

Skip to content

Feedback

This tutorial shows you how to build an emoji feedback cell in React using Handsontable’s EditorComponent, with per-column configuration and keyboard navigation.

JavaScript
import { useState, useEffect, useCallback } from 'react';
import { HotTable, HotColumn, EditorComponent } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import './example1.css';
// register Handsontable's modules
registerAllModules();
/* start:skip-in-preview */
export const data = [
{ feature: 'Dark Mode', category: 'UI', priority: 'High', feedback: '👍', votes: 124, status: 'Planned' },
{ feature: 'Bulk Edit', category: 'Core', priority: 'High', feedback: '👍', votes: 98, status: 'In Progress' },
{ feature: 'AI Suggestions', category: 'Beta', priority: 'Medium', feedback: '🤷', votes: 45, status: 'Research' },
{ feature: 'Offline Mode', category: 'Infra', priority: 'Low', feedback: '👎', votes: 12, status: 'Backlog' },
];
/* end:skip-in-preview */
export const FeedbackEditor = () => {
const [config, setConfig] = useState(['👍', '👎', '🤷']);
const [shortcuts, setShortcuts] = useState([]);
const onPrepare = (_row, _column, _prop, _TD, _originalValue, cellProperties) => {
setConfig(cellProperties.config);
};
useEffect(() => {
setShortcuts([
{
keys: [['ArrowRight'], ['Tab']],
callback: ({ value, setValue }, _event) => {
setValue(getNextValue(value));
return false;
},
},
{
keys: [['ArrowLeft']],
callback: ({ value, setValue }, _event) => {
setValue(getPrevValue(value));
},
},
]);
}, [config]);
const getNextValue = useCallback(
(value) => {
const index = config.indexOf(value);
return index === config.length - 1 ? config[0] : config[index + 1];
},
[config]
);
const getPrevValue = useCallback(
(value) => {
const index = config.indexOf(value);
return index === 0 ? config[config.length - 1] : config[index - 1];
},
[config]
);
return (
<EditorComponent onPrepare={onPrepare} shortcuts={shortcuts}>
{({ value, setValue, finishEditing }) => (
<>
<div className="feedback-editor">
{config.map((item, _index, _array) => (
<button
className={value === item ? 'active' : ''}
key={item}
onClick={() => {
setValue(item);
finishEditing();
}}
style={{
width: `${100 / _array.length}%`,
}}
>
{item}
</button>
))}
</div>
</>
)}
</EditorComponent>
);
};
const ExampleComponent = () => {
return (
<HotTable
autoRowSize={true}
rowHeaders={true}
autoWrapRow={true}
licenseKey="non-commercial-and-evaluation"
height="auto"
width="100%"
data={data}
colHeaders={['Feature', 'Category', 'Priority', 'Feedback', 'Votes', 'Status']}
headerClassName="htLeft"
>
<HotColumn data="feature" type="text" width={200} />
<HotColumn data="category" type="text" width={90} />
<HotColumn data="priority" type="text" width={100} />
<HotColumn data="feedback" type="text" width={100} editor={FeedbackEditor} config={['👍', '👎', '🤷']} />
<HotColumn data="votes" type="numeric" width={60} />
<HotColumn data="status" type="text" width={120} />
</HotTable>
);
};
export default ExampleComponent;
TypeScript
import { useState, useEffect, ComponentProps, useCallback } from 'react';
import { HotTable, HotColumn, EditorComponent } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import './example1.css';
// register Handsontable's modules
registerAllModules();
/* start:skip-in-preview */
export const data = [
{ feature: 'Dark Mode', category: 'UI', priority: 'High', feedback: '👍', votes: 124, status: 'Planned' },
{ feature: 'Bulk Edit', category: 'Core', priority: 'High', feedback: '👍', votes: 98, status: 'In Progress' },
{ feature: 'AI Suggestions', category: 'Beta', priority: 'Medium', feedback: '🤷', votes: 45, status: 'Research' },
{ feature: 'Offline Mode', category: 'Infra', priority: 'Low', feedback: '👎', votes: 12, status: 'Backlog' },
];
/* end:skip-in-preview */
type EditorComponentProps = ComponentProps<typeof EditorComponent<string>>;
export const FeedbackEditor = () => {
const [config, setConfig] = useState<string[]>(['👍', '👎', '🤷']);
const [shortcuts, setShortcuts] = useState<EditorComponentProps['shortcuts']>([]);
const onPrepare: EditorComponentProps['onPrepare'] = (_row, _column, _prop, _TD, _originalValue, cellProperties) => {
setConfig(cellProperties.config as string[]);
};
useEffect(() => {
setShortcuts([
{
keys: [['ArrowRight'], ['Tab']],
callback: ({value, setValue}, _event) => {
setValue(getNextValue(value));
return false;
}
},
{
keys: [['ArrowLeft']],
callback: ({value, setValue}, _event) => {
setValue(getPrevValue(value));
}
}
])
}, [config]);
const getNextValue = useCallback((value: string) => {
const index = config.indexOf(value);
return index === config.length - 1 ? config[0] : config[index + 1];
}, [config]);
const getPrevValue = useCallback((value: string) => {
const index = config.indexOf(value);
return index === 0 ? config[config.length - 1] : config[index - 1];
}, [config]);
return (
<EditorComponent<string> onPrepare={onPrepare} shortcuts={shortcuts}>
{({ value, setValue, finishEditing }) => (
<>
<div className="feedback-editor">
{config.map((item, _index, _array) => (
<button
className={value === item ? 'active' : ''}
key={item}
onClick={() => {
setValue(item);
finishEditing();
}}
style={{
width: 100 / _array.length + '%'
}}
>
{item}
</button>
))}
</div>
</>
)}
</EditorComponent>
);
};
const ExampleComponent = () => {
return (
<HotTable
autoRowSize={true}
rowHeaders={true}
autoWrapRow={true}
licenseKey="non-commercial-and-evaluation"
height="auto"
width="100%"
data={data}
colHeaders={['Feature', 'Category', 'Priority', 'Feedback', 'Votes', 'Status']}
headerClassName="htLeft"
>
<HotColumn data="feature" type="text" width={200} />
<HotColumn data="category" type="text" width={90} />
<HotColumn data="priority" type="text" width={100} />
<HotColumn data="feedback" type="text" width={100} editor={FeedbackEditor} config={['👍', '👎', '🤷']} />
<HotColumn data="votes" type="numeric" width={60} />
<HotColumn data="status" type="text" width={120} />
</HotTable>
);
};
export default ExampleComponent;
CSS
.feedback-editor {
display: flex;
gap: var(--ht-gap, 4px);
width: 100%;
height: 100%;
box-sizing: border-box !important;
padding: var(--ht-cell-vertical-padding, 4px) var(--ht-cell-horizontal-padding, 8px);
background-color: var(--ht-cell-editor-background-color, #ffffff);
box-shadow: inset 0 0 0 var(--ht-cell-editor-border-width, 2px)
var(--ht-cell-editor-border-color, #1a42e8),
0 0 var(--ht-cell-editor-shadow-blur-radius, 0) 0
var(--ht-cell-editor-shadow-color, transparent);
border: none;
border-radius: 0;
}
.feedback-editor button {
background: var(--ht-background-color, #ffffff);
color: var(--ht-foreground-color, #000000);
border: 1px solid var(--ht-border-color, #e0e0e0);
border-radius: var(--ht-border-radius, 4px);
padding: 0;
margin: 0;
height: 100%;
width: 33%;
font-size: var(--ht-font-size, 14px);
text-align: center;
cursor: pointer;
}
.feedback-editor button:hover {
background: var(--ht-border-color, #e0e0e0);
}
.feedback-editor button.active,
.feedback-editor button.active:hover {
background: var(--ht-accent-color, #1a42e8);
color: #ffffff;
border-color: var(--ht-accent-color, #1a42e8);
}

Overview

This guide shows how to create a feedback editor cell using emoji buttons (👍, 👎, 🤷) with React’s EditorComponent. The example uses a feature-roadmap table with a Feedback column; the editor supports quick selection, keyboard navigation (Arrow keys, Tab), and per-column configuration via external CSS.

Difficulty: Beginner Time: ~15 minutes Libraries: None

What You’ll Build

A cell that:

  • Displays emoji feedback buttons (👍, 👎, 🤷) when editing
  • Shows the selected emoji when viewing
  • Supports keyboard navigation (Arrow Left/Right and Tab to cycle options)
  • Provides click-to-select and closes the editor on choice
  • Uses React’s EditorComponent with render prop and external CSS (e.g. feedback-editor class)
  • Reads per-column options from cellProperties.config in onPrepare

Prerequisites

Terminal window
npm install @handsontable/react-wrapper

What you need:

  • React 16.8+ (hooks support)
  • @handsontable/react-wrapper package
  • Basic React knowledge (hooks, JSX)
  1. Import Dependencies

    import { useState, useEffect, useCallback, ComponentProps } from 'react';
    import { HotTable, HotColumn, EditorComponent } from '@handsontable/react-wrapper';
    import { registerAllModules } from 'handsontable/registry';
    registerAllModules();

    What we’re importing:

    • EditorComponent - React component for creating custom editors
    • HotTable and HotColumn - React wrapper components
    • React hooks for state management
    • Handsontable styles
  2. Create the Editor Component

    Create a React component that uses EditorComponent with the render prop pattern.

    type EditorComponentProps = ComponentProps<typeof EditorComponent<string>>;
    const FeedbackEditor = () => {
    const [config, setConfig] = useState<string[]>(['👍', '👎', '🤷']);
    return (
    <EditorComponent<string>>
    {({ value, setValue, finishEditing }) => (
    <div className="editor">
    {config.map((item) => (
    <button
    key={item}
    className={`button ${value === item ? 'active' : ''}`}
    onClick={() => {
    setValue(item);
    finishEditing();
    }}
    >
    {item}
    </button>
    ))}
    </div>
    )}
    </EditorComponent>
    );
    };

    What’s happening:

    1. EditorComponent wraps your editor UI
    2. The children prop is a function that receives editor state
    3. value - Current editor value
    4. setValue - Function to update the value
    5. finishEditing - Function to save and close the editor
    6. Render buttons for each option in the config
    7. Highlight the active button based on current value

    Key concepts:

    • Render prop pattern: EditorComponent uses a function as children
    • State management: value and setValue are provided by EditorComponent
    • React components: Use standard React patterns (JSX, className, onClick)
  3. Add Styling

    Style the editor container and buttons using CSS or inline styles.

    const FeedbackEditor = () => {
    const [config, setConfig] = useState<string[]>(['👍', '👎', '🤷']);
    return (
    <EditorComponent<string>>
    {({ value, setValue, finishEditing }) => (
    <>
    <style>{`
    .editor {
    box-sizing: border-box;
    display: flex;
    gap: 3px;
    padding: 3px;
    background: rgb(238, 238, 238);
    border: 1px solid rgb(204, 204, 204);
    border-radius: 4px;
    height: 100%;
    width: 100%;
    }
    .button.active {
    background: #007bff;
    color: white;
    }
    .button:hover {
    background: #f0f0f0;
    }
    .button {
    background: #fff;
    color: black;
    border: none;
    padding: 0;
    margin: 0;
    height: 100%;
    width: 100%;
    font-size: 16px;
    font-weight: bold;
    text-align: center;
    cursor: pointer;
    }
    `}</style>
    <div className="editor">
    {config.map((item, _index, _array) => (
    <button
    key={item}
    className={`button ${value === item ? 'active' : ''}`}
    onClick={() => {
    setValue(item);
    finishEditing();
    }}
    style={{
    width: `${100 / _array.length}%`
    }}
    >
    {item}
    </button>
    ))}
    </div>
    </>
    )}
    </EditorComponent>
    );
    };

    What’s happening:

    • Container uses flexbox for horizontal button layout
    • Buttons dynamically size based on config length
    • Active button has blue background
    • Hover effects for better UX

    Key styling:

    • display: flex - Horizontal button layout
    • gap: 3px - Space between buttons
    • width: ${100 / _array.length}% - Dynamic button width
    • .active class - Highlights selected button
  4. Read Config from Cell Properties

    Use onPrepare to read per-column configuration.

    const FeedbackEditor = () => {
    const [config, setConfig] = useState<string[]>(['👍', '👎', '🤷']);
    const onPrepare: EditorComponentProps['onPrepare'] = (
    _row,
    _column,
    _prop,
    _TD,
    _originalValue,
    cellProperties
    ) => {
    // Read config from column definition
    if (cellProperties.config) {
    setConfig(cellProperties.config as string[]);
    }
    };
    return (
    <EditorComponent<string> onPrepare={onPrepare}>
    {({ value, setValue, finishEditing }) => (
    // ... editor UI
    )}
    </EditorComponent>
    );
    };

    What’s happening:

    • onPrepare is called before the editor opens
    • cellProperties contains column-specific configuration
    • Read config from cellProperties.config
    • Update state to reflect column-specific options

    Why this matters:

    • Different columns can have different options
    • One editor component, multiple configurations
    • Dynamic options based on column settings
  5. Add Keyboard Shortcuts

    Add keyboard navigation using the shortcuts prop.

    const FeedbackEditor = () => {
    const [config, setConfig] = useState<string[]>(['👍', '👎', '🤷']);
    const [shortcuts, setShortcuts] = useState<EditorComponentProps['shortcuts']>([]);
    const getNextValue = useCallback((value: string) => {
    const index = config.indexOf(value);
    return index === config.length - 1 ? config[0] : config[index + 1];
    }, [config]);
    const getPrevValue = useCallback((value: string) => {
    const index = config.indexOf(value);
    return index === 0 ? config[config.length - 1] : config[index - 1];
    }, [config]);
    useEffect(() => {
    setShortcuts([
    {
    keys: [['ArrowRight'], ['Tab']],
    callback: ({ value, setValue }, _event) => {
    setValue(getNextValue(value));
    return false; // Prevent default Tab behavior
    }
    },
    {
    keys: [['ArrowLeft']],
    callback: ({ value, setValue }, _event) => {
    setValue(getPrevValue(value));
    }
    }
    ]);
    }, [config, getNextValue, getPrevValue]);
    return (
    <EditorComponent<string> shortcuts={shortcuts}>
    {({ value, setValue, finishEditing }) => (
    // ... editor UI
    )}
    </EditorComponent>
    );
    };

    What’s happening:

    • ArrowRight/Tab: Move to next option (wraps to first if at end)
    • ArrowLeft: Move to previous option (wraps to last if at start)
    • callback receives { value, setValue, finishEditing } as first parameter
    • Return false to prevent default behavior (e.g., Tab moving to next cell)

    Keyboard navigation benefits:

    • Fast selection without mouse
    • Accessible for keyboard-only users
    • Intuitive left/right navigation
    • Tab cycles through options instead of moving cells
  6. Complete Editor Component

    Put it all together:

    type EditorComponentProps = ComponentProps<typeof EditorComponent<string>>;
    const FeedbackEditor = () => {
    const [config, setConfig] = useState<string[]>(['👍', '👎', '🤷']);
    const [shortcuts, setShortcuts] = useState<EditorComponentProps['shortcuts']>([]);
    const onPrepare: EditorComponentProps['onPrepare'] = (
    _row,
    _column,
    _prop,
    _TD,
    _originalValue,
    cellProperties
    ) => {
    if (cellProperties.config) {
    setConfig(cellProperties.config as string[]);
    }
    };
    const getNextValue = useCallback((value: string) => {
    const index = config.indexOf(value);
    return index === config.length - 1 ? config[0] : config[index + 1];
    }, [config]);
    const getPrevValue = useCallback((value: string) => {
    const index = config.indexOf(value);
    return index === 0 ? config[config.length - 1] : config[index - 1];
    }, [config]);
    useEffect(() => {
    setShortcuts([
    {
    keys: [['ArrowRight'], ['Tab']],
    callback: ({ value, setValue }, _event) => {
    setValue(getNextValue(value));
    return false;
    }
    },
    {
    keys: [['ArrowLeft']],
    callback: ({ value, setValue }, _event) => {
    setValue(getPrevValue(value));
    }
    }
    ]);
    }, [config, getNextValue, getPrevValue]);
    return (
    <EditorComponent<string> onPrepare={onPrepare} shortcuts={shortcuts}>
    {({ value, setValue, finishEditing }) => (
    <>
    <style>{`
    .editor {
    box-sizing: border-box;
    display: flex;
    gap: 3px;
    padding: 3px;
    background: rgb(238, 238, 238);
    border: 1px solid rgb(204, 204, 204);
    border-radius: 4px;
    height: 100%;
    width: 100%;
    }
    .button.active:hover,
    .button.active {
    background: #007bff;
    color: white;
    }
    .button:hover {
    background: #f0f0f0;
    }
    .button {
    background: #fff;
    color: black;
    border: none;
    padding: 0;
    margin: 0;
    height: 100%;
    width: 100%;
    font-size: 16px;
    font-weight: bold;
    text-align: center;
    cursor: pointer;
    }
    `}</style>
    <div className="editor">
    {config.map((item, _index, _array) => (
    <button
    key={item}
    className={`button ${value === item ? 'active' : ''}`}
    onClick={() => {
    setValue(item);
    finishEditing();
    }}
    style={{
    width: `${100 / _array.length}%`
    }}
    >
    {item}
    </button>
    ))}
    </div>
    </>
    )}
    </EditorComponent>
    );
    };

    What’s happening:

    • State management: config and shortcuts managed with React hooks
    • onPrepare: Reads column-specific config
    • shortcuts: Keyboard navigation handlers
    • Render prop: Renders buttons based on config
    • Styling: CSS-in-JS for editor appearance
  7. Use in Handsontable

    Use the editor component in your HotTable:

    const ExampleComponent = () => {
    return (
    <HotTable
    autoRowSize={true}
    rowHeaders={true}
    autoWrapRow={true}
    licenseKey="non-commercial-and-evaluation"
    height="auto"
    data={data}
    colHeaders={true}
    >
    <HotColumn
    width={250}
    editor={FeedbackEditor}
    config={['👍', '👎', '🤷']}
    data="feedback"
    title="Feedback"
    />
    <HotColumn
    width={250}
    editor={FeedbackEditor}
    config={['1', '2', '3', '4', '5']}
    data="stars"
    title="Rating (1-5)"
    />
    </HotTable>
    );
    };

    What’s happening:

    • editor={FeedbackEditor} - Assigns the editor component to the column
    • config={['👍', '👎', '🤷']} - Column-specific options
    • Same editor component, different configurations per column

    Key features:

    • Reusable editor component
    • Per-column configuration
    • Type-safe with TypeScript

How It Works - Complete Flow

  1. Initial Render: Cell displays the emoji value (👍, 👎, or 🤷)
  2. User Double-Clicks or Enter: Editor opens, onPrepare reads column config
  3. Editor Opens: EditorComponent positions container over cell
  4. Button Display: All options visible, current value highlighted
  5. User Interaction:
    • Click a button → setValue(item) and finishEditing() called
    • Press ArrowLeft/Right → Shortcut callback updates value
    • Press Tab → Cycles through options (prevents default cell navigation)
  6. Visual Feedback: Selected button highlighted in blue
  7. User Confirms: Press Enter, click button, or click away
  8. Save: Value saved to cell
  9. Editor Closes: Cell shows selected emoji

Enhancements

  1. Custom Renderer with Styling

    Add a custom renderer to style the emoji display:

    import { rendererFactory } from 'handsontable/renderers';
    const cellDefinition = {
    renderer: rendererFactory(({ td, value }) => {
    td.innerHTML = `
    <div style="text-align: center; font-size: 1.5em; padding: 4px;">
    ${value || '🤷'}
    </div>
    `;
    })
    };
    // Use in HotColumn
    <HotColumn
    editor={FeedbackEditor}
    renderer={cellDefinition.renderer}
    config={['👍', '👎', '🤷']}
    data="feedback"
    />

    What’s happening:

    • Center-aligns the emoji
    • Increases font size for better visibility
    • Adds padding for spacing
  2. More Feedback Options

    Add more emoji options:

    <HotColumn
    editor={FeedbackEditor}
    config={['👍', '👎', '🤷', '❤️', '🔥', '⭐']}
    data="feedback"
    />

    The editor automatically adjusts button widths based on config length.

  3. Custom Button Styling

    Enhanced button appearance with CSS:

    <style>{`
    .button {
    padding: 8px;
    border: 2px solid #ddd;
    background: white;
    color: #333;
    border-radius: 4px;
    cursor: pointer;
    font-size: 1.2em;
    transition: all 0.2s;
    }
    .button.active {
    border-color: #007bff;
    background: #007bff;
    color: white;
    }
    .button:hover {
    transform: scale(1.05);
    box-shadow: 0 2px 4px rgba(0, 0, 0, 0.2);
    }
    `}</style>
  4. Dynamic Config from Cell Properties

    The onPrepare hook already handles this — pass different configs:

    <HotColumn
    editor={FeedbackEditor}
    config={['👍', '👎', '❤️', '🔥']}
    data="feedback"
    />
  5. Tooltip on Hover

    Add tooltips to buttons:

    {config.map((item) => {
    const tooltips: Record<string, string> = {
    '👍': 'Positive feedback',
    '👎': 'Negative feedback',
    '🤷': 'Neutral feedback'
    };
    return (
    <button
    key={item}
    className={`button ${value === item ? 'active' : ''}`}
    onClick={() => {
    setValue(item);
    finishEditing();
    }}
    title={tooltips[item] || ''}
    >
    {item}
    </button>
    );
    })}
  6. Text Labels Instead of Emojis

    Use text buttons for clarity:

    <HotColumn
    editor={FeedbackEditor}
    config={['Positive', 'Negative', 'Neutral']}
    data="feedback"
    />

    The editor works with any string values, not just emojis.

  7. Using External CSS File

    Move styles to a separate CSS file:

    feedback-editor.css
    .editor {
    box-sizing: border-box;
    display: flex;
    gap: 3px;
    padding: 3px;
    background: rgb(238, 238, 238);
    border: 1px solid rgb(204, 204, 204);
    border-radius: 4px;
    height: 100%;
    width: 100%;
    }
    .button.active {
    background: #007bff;
    color: white;
    }
    .button:hover {
    background: #f0f0f0;
    }
    .button {
    background: #fff;
    color: black;
    border: none;
    padding: 0;
    margin: 0;
    height: 100%;
    width: 100%;
    font-size: 16px;
    font-weight: bold;
    text-align: center;
    cursor: pointer;
    }
    import './feedback-editor.css';
    const FeedbackEditor = () => {
    // ... component code without <style> tag
    };

Accessibility

React buttons are inherently accessible, but you can enhance them:

{config.map((item, index) => (
<button
key={item}
className={`button ${value === item ? 'active' : ''}`}
onClick={() => {
setValue(item);
finishEditing();
}}
aria-label={`${item} feedback option`}
aria-pressed={value === item}
tabIndex={value === item ? 0 : -1}
>
{item}
</button>
))}

Keyboard navigation:

  • Tab: Navigate to editor (focuses active button)
  • Arrow Left/Right: Cycle through options (via shortcuts)
  • Enter: Select current option and finish editing
  • Escape: Cancel editing
  • Click: Direct selection

ARIA attributes:

  • aria-label: Describes each button
  • aria-pressed: Indicates selected state
  • tabIndex: Controls keyboard focus order

Performance Considerations

Why This Is Fast

  1. React Virtual DOM: Efficient updates only when value changes
  2. No External Libraries: Zero overhead beyond React
  3. Efficient Re-renders: Only re-renders when config or value changes
  4. Native Events: Browser-optimized click handlers

React Hooks Optimization

The useCallback and useEffect hooks ensure shortcuts are only recreated when config changes:

const getNextValue = useCallback((value: string) => {
const index = config.indexOf(value);
return index === config.length - 1 ? config[0] : config[index + 1];
}, [config]); // Only recreate if config changes
useEffect(() => {
setShortcuts([...]);
}, [config, getNextValue, getPrevValue]); // Only update when dependencies change

TypeScript Support

EditorComponent is fully typed. You can specify the value type:

<EditorComponent<string>>
{({ value, setValue, finishEditing }) => {
// TypeScript knows value is string | undefined
// TypeScript knows setValue accepts string
return (
// ... editor UI
);
}}
</EditorComponent>

For number-based feedback:

<EditorComponent<number>>
{({ value, setValue, finishEditing }) => {
// TypeScript knows value is number | undefined
return (
// ... editor UI
);
}}
</EditorComponent>

Best Practices

  1. Use onPrepare for per-cell configuration - Access cellProperties to read custom options
  2. Handle keyboard events properly - Use shortcuts for navigation
  3. Call finishEditing() appropriately - When user confirms changes (Enter, blur, button click)
  4. Keep render prop function focused - Extract complex logic into separate components or hooks
  5. Use useCallback for helper functions - Prevents unnecessary re-renders
  6. Update shortcuts in useEffect - Ensures shortcuts match current config

What you learned

You built an emoji feedback cell editor in React using Handsontable’s EditorComponent. You used the render prop pattern to render configurable option buttons, onPrepare to read per-column configuration from cellProperties, and the shortcuts prop for keyboard navigation.

Next steps